AppTitle "Insanity"

Graphics3D 800,600
SetBuffer BackBuffer()
SeedRnd MilliSecs()

Type MazeWallType
	Field x,z,ent
End Type

Type PlayerShotType
	Field entity
End Type

Type enemytype
	Field entity,lastnode,destnode,hp,ft,pa,ca,shadow,evilhillary,bounce
End Type

Type mazedamagetype
	Field sprite
End Type

Type enemyshottype
	Field sprite,ang
End Type

Type particletype
	Field sprite,mx#,my#,mz#
End Type

Type smallexplosiontype
	Field entity,size#,alpha#,typ
End Type

Type robotpiecetype
	Field mx#,my#,mz#,rx#,ry#,rz#,entity,typ
End Type

Type probotpiecetype
	Field entity
End Type

Type explosionsoundtype
	Field entity
End Type

;FONTS
Global LargeFont=LoadFont("Arial",50,True,False,False)
Global SmallFont=LoadFont("arial",20,False,False,False)

;LOAD 2D GRAPHICS
Global TitleScreenImg=LoadImage("2dgfx\title.jpg")

;LOAD TEXTURES
Global MazeTextureWalls=LoadTexture("textures\maze.jpg"):ScaleTexture MazeTextureWalls,0.5,0.5
Global Wall1Texture=LoadTexture("textures\wall1.png")
Global Wall2Texture=LoadTexture("textures\wall2.png")
Global Wall3Texture=LoadTexture("textures\wall3.png")
Global Wall4Texture=LoadTexture("textures\wall4.png")
Global Wall5Texture=LoadTexture("textures\wall5.png")
Global Wall6Texture=LoadTexture("textures\wall6.png")
Global Wall10Texture=LoadTexture("textures\wall10.png")
Global MazeTextureFloorAndCeiling=LoadTexture("textures\floorceilingtile.jpg"):ScaleTexture MazeTextureFloorAndCeiling,0.05,0.05
Global Lysoskin=LoadTexture("textures\lysoskin.jpg")
Global CyborgVixenSkin=LoadTexture("textures\cyborgvixenskin.jpg")
Global EvilHillarySkin=LoadTexture("textures\evil-hillary.jpg")
Global WeaponSkin=LoadTexture("textures\weapon.jpg")

;LOAD MESHES, CREATE ENTITIES
Global Wall1Mesh=LoadMesh("meshes\wall1.b3d"):EntityTexture Wall1Mesh,Wall1Texture:HideEntity Wall1Mesh
Global Wall2Mesh=LoadMesh("meshes\wall2.b3d"):EntityTexture Wall2Mesh,Wall2Texture:HideEntity Wall2Mesh
Global Wall3Mesh=LoadMesh("meshes\wall3.b3d"):EntityTexture Wall3Mesh,Wall3Texture:HideEntity Wall3Mesh
Global Wall4Mesh=LoadMesh("meshes\wall4.b3d"):EntityTexture Wall4Mesh,Wall4Texture:HideEntity Wall4Mesh
Global Wall5Mesh=LoadMesh("meshes\wall5.b3d"):EntityTexture Wall5Mesh,Wall5Texture:HideEntity Wall5Mesh
Global Wall6Mesh=LoadMesh("meshes\wall6.b3d"):EntityTexture Wall6Mesh,Wall6Texture:HideEntity Wall6Mesh
Global Wall10Mesh=LoadMesh("meshes\wall10.b3d"):EntityTexture Wall10Mesh,Wall10Texture:HideEntity Wall10Mesh
Global PlayerShotMesh=LoadMesh("meshes\playerbullet.3ds"):EntityColor PlayerShotMesh,255,255,0:HideEntity PlayerShotMesh
Global FloorMesh=LoadMesh("meshes\floor.3ds"):EntityBox FloorMesh,-500,0,-500,1000,10,1000
EntityTexture floormesh,MazeTextureFloorAndCeiling
Global CeilingMesh=CopyEntity(FloorMesh)

Global Lysozyme=LoadAnimMesh("meshes\Lysozyme.b3d"):ScaleEntity Lysozyme,1.2,1.2,1.2:EntityColor Lysozyme,255,255,255:EntityRadius Lysozyme,10
EntityBox Lysozyme,-15,0,-15,30,40,30
EntityTexture Lysozyme,LysoSkin
ExtractAnimSeq Lysozyme,1,10   ;Standing
ExtractAnimSeq Lysozyme,11,27  ;Running
ExtractAnimSeq Lysozyme,28,40  ;Death
Global WeaponMesh=LoadMesh("meshes\weapon.b3d"):EntityColor WeaponMesh,255,255,255:ScaleEntity WeaponMesh,0.2,0.2,0.2
EntityTexture WeaponMesh,WeaponSkin
Global AimingGuide=LoadMesh("meshes\aimingguide.b3d"):EntityColor AimingGuide,255,0,0:EntityFX AimingGuide,1

Global CyborgVixen=LoadAnimMesh("meshes\cyborgvixen.b3d"):ScaleEntity CyborgVixen,1,1,1:EntityColor CyborgVixen,255,255,255
EntityShininess CyborgVixen,0.4
EntityBox CyborgVixen,-15,0,-15,30,40,30
EntityTexture CyborgVixen,CyborgVixenSkin
ExtractAnimSeq CyborgVixen,1,9      ;Standing
ExtractAnimSeq CyborgVixen,10,22    ;Walking
ExtractAnimSeq CyborgVixen,23,25    ;Shooting
HideEntity CyborgVixen

Dim RobotPieceMesh(8)
RobotPieceMesh(1)=LoadMesh("meshes\part-arm.b3d")
RobotPieceMesh(2)=CopyEntity(RobotPieceMesh(1))
RobotPieceMesh(3)=LoadMesh("meshes\part-leg.b3d")
RobotPieceMesh(4)=CopyEntity(RobotPieceMesh(3))
RobotPieceMesh(5)=LoadMesh("meshes\part-tail.b3d")
RobotPieceMesh(6)=LoadMesh("meshes\part-abdomen.b3d")
RobotPieceMesh(7)=LoadMesh("meshes\part-thorax.b3d")
RobotPieceMesh(8)=LoadMesh("meshes\part-head.b3d")

For a=1 To 8
	ScaleEntity RobotPieceMesh(a),0.5,0.5,0.5
	EntityShininess RobotPieceMesh(a),0.4
	EntityColor RobotPieceMesh(a),255,255,255
	EntityRadius RobotPieceMesh(a),5
	HideEntity RobotPieceMesh(a)
	EntityTexture RobotPieceMesh(a),CyborgVixenSkin
Next

Global EvilHillaryMesh=LoadMesh("meshes\evil-hillary.b3d"):ScaleEntity EvilHillaryMesh,5,5,5:HideEntity EvilHillaryMesh
EntityTexture EvilHillaryMesh,EvilHillarySkin
EntityBox EvilHillaryMesh,-15,-50,-15,30,130,30
Global ExplosionMesh=CreateSphere(8):EntityColor ExplosionMesh,255,255,0:EntityFX ExplosionMesh,16:HideEntity ExplosionMesh
Global MazeBorderMesh=CreateCube():ScaleEntity MazeBorderMesh,500,100,10:EntityColor MazeBorderMesh,0,0,0:HideEntity MazeBorderMesh
Global MazeBorder1=CopyEntity(MazeBorderMesh):PositionEntity MazeBorder1,500,-10,-30
Global MazeBorder2=CopyEntity(MazeBorderMesh):RotateEntity MazeBorder2,0,90,0:PositionEntity MazeBorder2,1030,-10,500
Global MazeBorder3=CopyEntity(MazeBorderMesh):RotateEntity MazeBorder3,0,180,0:PositionEntity MazeBorder3,500,-10,1030
Global MazeBorder4=CopyEntity(MazeBorderMesh):RotateEntity MazeBorder4,0,270,0:PositionEntity MazeBorder4,-30,-10,500

;CREATE SPRITES
Global ShotDamageSprite=LoadSprite("sprites\splat.png"):ScaleSprite ShotDamageSprite,10,10:HideEntity ShotDamageSprite:SpriteViewMode ShotDamageSprite,2:EntityBlend ShotDamageSprite,2
Global EnemyShotSprite=LoadSprite("sprites\enemyshot.png"):ScaleSprite EnemyShotSprite,10,10:HideEntity EnemyShotSprite:SpriteViewMode EnemyShotSprite,1
Global ParticleSprite=LoadSprite("sprites\particle.png"):ScaleSprite ParticleSprite,2,2:HideEntity ParticleSprite:SpriteViewMode ParticleSprite,1
Global ShadowSprite=LoadSprite("sprites\shadow.png"):ScaleSprite ShadowSprite,30,30:HideEntity ShadowSprite:SpriteViewMode ShadowSprite,2:EntityBlend ShadowSprite,2
Global LysozymeShadow=CopyEntity(ShadowSprite)

;CREATE PIVOTS
Global playershotorigin=CreatePivot(Lysozyme)
Global ExplosionSoundPivot=CreatePivot()
Global LysozymeCameraPivot=CreatePivot(Lysozyme)
EntityParent AimingGuide,playershotorigin
EntityParent WeaponMesh,AimingGuide

;CREATE CAMERA
Global Camera=CreateCamera(LysozymeCameraPivot):EntityRadius camera,1
CameraViewport Camera,0,0,800,600
CameraRange camera,1,10000

;CREATE LIGHTS
Global light=CreateLight(2):LightRange light,1000
Global light2=CreateLight(2):LightRange light2,1000

;COLLISION STUFF
Const coll_Lysozyme=1
Const coll_playershot=2
Const coll_enemyrobot=3
Const coll_mazewall=4
Const coll_enemyshot=5
Const coll_robotpiece=6
Const coll_mazefloor=7
Const coll_mazeceiling=8
Const coll_camera=9

EntityType Lysozyme,coll_Lysozyme
EntityType camera,coll_camera

Collisions coll_playershot,coll_enemyrobot,3,1
Collisions coll_playershot,coll_mazewall,3,1
Collisions coll_playershot,coll_mazefloor,3,1
Collisions coll_playershot,coll_mazeceiling,3,1
Collisions coll_Lysozyme,coll_mazewall,3,2
Collisions coll_Lysozyme,coll_enemyrobot,3,2
Collisions coll_enemyshot,coll_mazewall,3,1
Collisions coll_particle,coll_mazewall,3,1
Collisions coll_robotpiece,coll_mazewall,3,2
Collisions coll_robotpiece,coll_mazeceiling,3,2
Collisions coll_robotpiece,coll_mazefloor,3,2
Collisions coll_enemyshot,coll_Lysozyme,3,1
;Collisions coll_camera,coll_mazewall,3,2
;Collisions coll_camera,coll_mazefloor,3,2
;Collisions coll_camera,coll_mazeceiling,3,2


;SOUNDS
;microphone
Global Microphone=CreateListener(Lysozyme,0.005)
;3D
Dim Taunt(3),Beeps(5),PlayerDeathTaunt(2),Laugh(3)
Taunt(1)=Load3DSound("audio\taunt1.mp3")
Taunt(2)=Load3DSound("audio\taunt2.mp3")
Taunt(3)=Load3DSound("audio\taunt3.mp3")
Beeps(1)=Load3DSound("audio\beeps1.mp3")
Beeps(2)=Load3DSound("audio\beeps2.mp3")
Beeps(3)=Load3DSound("audio\beeps3.mp3")
Beeps(4)=Load3DSound("audio\beeps4.mp3")
Beeps(5)=Load3DSound("audio\beeps5.mp3")
Laugh(1)=Load3DSound("audio\laugh1.mp3")
Laugh(2)=Load3DSound("audio\laugh2.mp3")
Laugh(3)=Load3DSound("audio\laugh3.mp3")
For a=1 To 5:SoundVolume Beeps(a),0.1:Next
Global SmallExplosionSound=Load3DSound("audio\smallexplosion.mp3"):SoundVolume SmallExplosionSound,0.3
Global LargeExplosionSound=Load3DSound("audio\largeexplosion.mp3")
Global CyborgShootSound=Load3DSound("audio\cyborgshoot.mp3"):SoundVolume CyborgShootSound,0.3

;2D
Dim Grunt(6)
PlayerDeathTaunt(1)=LoadSound("audio\playerdeathtaunt1.mp3")
PlayerDeathTaunt(2)=LoadSound("audio\playerdeathtaunt2.mp3")
Grunt(1)=LoadSound("audio\grunt1.mp3")
Grunt(2)=LoadSound("audio\grunt2.mp3")
Grunt(3)=LoadSound("audio\grunt3.mp3")
Grunt(4)=LoadSound("audio\grunt4.mp3")
Grunt(5)=LoadSound("audio\grunt5.mp3")
Grunt(6)=LoadSound("audio\grunt6.mp3")
Global PlayerDeathSound=LoadSound("audio\playerdeath.mp3")
Global PlayerShootSound=LoadSound("audio\playershoot.mp3"):SoundVolume PlayerShootSound,0.2
Global MusicEvilHillaryEnters=LoadSound("audio\music-evilhillaryenters.mp3")
Global MusicCyborgsDestroyed=LoadSound("audio\music-cyborgsdestroyed.mp3")
Global MusicExtraLife=LoadSound("audio\music-extralife.mp3")

;GAME VARIABLES
Const Gravity#=0.1
;Const MouseSensitivity#=0.2
Const ExtraLife=5000

Dim MazePost(4,11,11),MazeExitNode(4,2)
Dim NextNodeDistNo(5),NextNodeDist#(5)
Dim MazeNodeX(25),MazeNodeZ(25),MazeNodeConn(4,25,5),NodeOccupied(25)
Global HeadBob,PlayerDeathTimer,LevelStartTimer,MazeLevel,GameLevel,RedOutTimer,LastRedOutTimer,Score,ppa,pca
Global PlayerFireDelay,NextExtraLife,EvilHillaryTimer,AddedEvilHillary,MouseSensitivity#
Global OriginalRobotsInMaze,CurrentRobotsInMaze,ScoreForLevel,Lives,Health,CurrView
Global RobotTurnSpeed#,RobotSpeed#,RobotShootingSpeed,RobotShotSpeed#,RobotTalkTimer,RobotAnimSpeed#
Global FrameTimer=CreateTimer(60)

;MAZE NODES
;Maze 1
Data 2,6,0,0,0
Data 1,3,0,0,0
Data 2,8,4,0,0
Data 3,5,0,0,0
Data 4,10,0,0,0
Data 1,11,0,0,0
Data 12,13,8,0,0
Data 3,7,9,13,0
Data 8,13,14,0,0
Data 5,15,0,0,0
Data 6,16,0,0,0
Data 7,13,17,8,18
Data 12,14,8,18,0
Data 9,13,19,8,18
Data 10,20,0,0,0
Data 11,21,0,0,0
Data 12,13,18,0,0
Data 23,17,19,13,14
Data 18,13,14,0,0
Data 15,25,0,0,0
Data 16,22,0,0,0
Data 21,23,0,0,0
Data 22,24,18,0,0
Data 23,25,0,0,0
Data 20,24,0,0,0
Data 3,23

;Maze 2
Data 2,6,0,0,0
Data 1,3,0,0,0
Data 2,4,8,0,0
Data 3,5,0,0,0
Data 4,10,0,0,0
Data 1,11,0,0,0
Data 8,12,0,0,0
Data 7,3,9,0,0
Data 8,14,0,0,0
Data 5,15,0,0,0
Data 6,12,16,0,0
Data 7,11,17,13,0
Data 12,14,0,0,0
Data 9,13,19,15,0
Data 10,14,20,0,0
Data 11,21,0,0,0
Data 12,18,0,0,0
Data 17,23,19,0,0
Data 18,14,0,0,0
Data 25,15,0,0,0
Data 16,22,0,0,0
Data 21,23,0,0,0
Data 22,18,24,0,0
Data 23,25,0,0,0
Data 24,20,0,0,0
Data 11,15

;Maze 3
Data 2,6,0,0,0
Data 1,3,7,0,0
Data 2,4,0,0,0
Data 3,9,5,0,0
Data 4,10,0,0,0
Data 1,11,0,0,0
Data 2,12,0,0,0
Data 13,0,0,0,0
Data 4,14,0,0,0
Data 5,15,0,0,0
Data 6,16,0,0,0
Data 7,17,13,0,0
Data 8,12,18,14,0
Data 9,13,19,0,0
Data 10,20,0,0,0
Data 11,21,0,0,0
Data 12,22,0,0,0
Data 13,0,0,0,0
Data 14,24,0,0,0
Data 15,25,0,0,0
Data 16,22,0,0,0
Data 21,17,23,0,0
Data 22,24,0,0,0
Data 23,19,25,0,0
Data 20,24,0,0,0
Data 11,15

;Maze 4
Data 2,6,0,0,0
Data 1,3,0,0,0
Data 2,4,0,0,0
Data 3,9,5,0,0
Data 4,10,0,0,0
Data 1,7,11,0,0
Data 6,8,0,0,0
Data 7,9,0,0,0
Data 4,8,14,0,0
Data 5,15,0,0,0
Data 6,12,16,0,0
Data 11,17,13,0,0
Data 12,14,0,0,0
Data 13,9,15,0,0
Data 10,14,20,0,0
Data 11,21,0,0,0
Data 12,22,18,0,0
Data 19,17,0,0,0
Data 18,20,0,0,0
Data 15,19,25,0,0
Data 16,22,0,0,0
Data 21,17,23,0,0
Data 22,24,0,0,0
Data 23,25,0,0,0
Data 20,24,0,0,0
Data 3,23

;MAZE WALLS	0=empty space  1-6=walls 1-6 long  7=wall 10 long      +10 to rotate 90 deg CW (down)  +20 to rotate 180 deg  +30 to rotate 90 deg CCW (up)
;Maze 1
Data 04,00,00,00,00,00,04,00,00,00,17
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,16,00,22,00,02,00,16,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,00,00,22,00,02,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 37,00,00,00,24,00,00,00,00,00,24

;Maze 2
Data 07,00,00,00,00,00,00,00,00,00,14
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,02,00,00,00,02,00,12,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 34,00,32,00,02,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,12,00,02,00,00,00,00,00,14
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,02,00,00,00,02,00,32,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 34,00,00,00,00,00,00,00,00,00,27

;Maze 3
Data 07,00,00,00,00,00,00,00,00,00,14
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,16,00,02,00,00,00,16,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 34,00,00,00,32,00,32,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,00,00,12,00,12,00,00,00,14
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,00,00,02,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 34,00,00,00,00,00,00,00,00,00,27

;Maze 4
Data 04,00,00,00,00,00,04,00,00,00,17
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,04,00,00,00,00,00,12,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,04,00,00,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,12,00,04,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 00,00,00,00,04,00,00,00,00,00,00
Data 00,00,00,00,00,00,00,00,00,00,00
Data 37,00,00,00,24,00,00,00,00,00,24

TitleScreen
InitializeVariables
NewLevel(1)

PositionEntity Lysozyme,500,0,500:PositionEntity LysozymeCameraPivot,0,30,0
SnapToView(CurrView)
SetLysoAnim(1,0.1)
PositionEntity playershotorigin,507,27,500,1;:TurnEntity playershotorigin,-1,5,0
MoveEntity AimingGuide,0,-8,0
MoveEntity WeaponMesh,0,0,-5
PositionEntity light,500,900,500
PositionEntity light2,500,-900,500
NewPlayer
MoveMouse 300,300

;PositionEntity EvilHillaryMesh,500,30,500
While Not KeyDown(1)		

	TurnEntity EvilHillaryMesh,0,3,0
	kk=GetKey()
	h=0
	If PlayerDeathTimer=0 Then
		If kk=Asc("1") Then SnapToView(1):CurrView=1
		If kk=Asc("2") Then SnapToView(2):CurrView=2
		If CurrView=2 Then HeadBob=0
		
		If kk=Asc("P") Or kk=Asc("p") Then
			SetFont LargeFont:Color 255,255,255
			Text 400,300,"PAUSED",True,True
			Flip
			Repeat
				pp=GetKey()			
			Until pp=Asc("P") Or pp=Asc("p")
			MoveMouse 300,300
		EndIf
		
		If CurrView=1 And EntityZ(camera)<0 Then MoveEntity camera,0,0,2
		If CurrView=2 And EntityZ(camera)>-40 Then MoveEntity camera,0,0,-2
		If EntityYaw(LysozymeCameraPivot)>=2 Then TurnEntity LysozymeCameraPivot,0,-4,0
		If EntityYaw(LysozymeCameraPivot)<=-2 Then TurnEntity LysozymeCameraPivot,0,4,0
		If EntityYaw(LysozymeCameraPivot)>-2 And EntityYaw(LysozymeCameraPivot)<2 Then RotateEntity LysozymeCameraPivot,0,0,0
		
		;Forwards
		If KeyDown(200) Then 
		MoveEntity Lysozyme,0,0,4:PositionEntity Lysozyme,EntityX(Lysozyme),(2*Sin(HeadBob)),EntityZ(Lysozyme):If h=0 Then HeadBob=HeadBob+15:h=1
			SetLysoAnim(2,0.5)
		EndIf
		;Backwards
		If KeyDown(208) Then 
			MoveEntity Lysozyme,0,0,-4:PositionEntity Lysozyme,EntityX(Lysozyme),(2*Sin(HeadBob)),EntityZ(Lysozyme):If h=0 Then HeadBob=HeadBob+15:h=1
			SetLysoAnim(2,0.5)
		EndIf
		;Strafe Right
		If KeyDown(205) Then 
			MoveEntity Lysozyme,3,0,0:PositionEntity Lysozyme,EntityX(Lysozyme),0+(2*Sin(HeadBob)),EntityZ(Lysozyme):If h=0 Then HeadBob=HeadBob+15:h=0
			SetLysoAnim(2,0.5)
		EndIf
		;Strafe Left
		If KeyDown(203) Then 
			MoveEntity Lysozyme,-3,0,0:PositionEntity Lysozyme,EntityX(Lysozyme),0+(2*Sin(HeadBob)),EntityZ(Lysozyme):If h=0 Then HeadBob=HeadBob+15:h=1
			SetLysoAnim(2,0.5)
		EndIf
	
		If KeyDown(200)=False And KeyDown(208)=False And KeyDown(205)=False And KeyDown(203)=False Then SetLysoAnim(1,0.1)
	
		;Mouse movement
		mx#=MouseXSpeed():my#=MouseYSpeed():MoveMouse 300,300
		TurnEntity Lysozyme,0,-mx*MouseSensitivity,0
		TurnEntity camera,my*MouseSensitivity,0,0
		TurnEntity AimingGuide,my*MouseSensitivity,0,0
		If currview=2 Then TurnEntity LysozymeCameraPivot,0,mx*MouseSensitivity,0
		If EntityPitch(camera)>70 Then RotateEntity camera,70,0,0:RotateEntity AimingGuide,70,0,0
		If EntityPitch(camera)<-70 Then RotateEntity camera,-70,0,0:RotateEntity AimingGuide,-70,0,0
		If CurrView=2 And EntityDistance(camera,Lysozyme)>65 Then 
			RotateEntity LysozymeCameraPivot,0,0,0
			HideEntity camera
			PositionEntity camera,0,0,-40
			ShowEntity camera
		EndIf
	
		If MouseDown(1) And PlayerFireDelay=8 Then AddPlayerShot:PlayerFireDelay=0
		
	EndIf
	
	PlayerFireDelay=PlayerFireDelay+1
	If PlayerFireDelay>5 Then PlayerFireDelay=8
	If HeadBob>359 Then HeadBob=0
	
	LevelStartTimer=LevelStartTimer+1
	If LevelStartTimer>1000 Then LevelStartTimer=1000
	
	If PlayerDeathTimer>0 Then PlayerDeathTimer=PlayerDeathTimer+1
	If PlayerDeathTimer>320 Then PlayerDeathTimer=0
	If PlayerDeathTimer=2 Then 
		SnapToView(3):PlaySound PlayerDeathSound
		PositionEntity Lysozyme,EntityX(Lysozyme),1,EntityZ(Lysozyme)
		Animate Lysozyme,3,0.15,3,1
	EndIf
	If PlayerDeathTimer=150 Then PlaySound PlayerDeathTaunt(Rand(1,2))
	If PlayerDeathTimer=200 Then NewPlayer:LevelStartTimer=0:PlayerDeathTimer=0
	
	If EntityX(Lysozyme)>1000 Or EntityX(Lysozyme)<0 Then PositionEntity Lysozyme,500,0,500:EndLevel
	If EntityZ(Lysozyme)>1000 Or EntityZ(Lysozyme)<0 Then PositionEntity Lysozyme,500,0,500:EndLevel
	
	For enemy.enemytype=Each enemytype
		If EntityDistance(Lysozyme,enemy\entity)<(15+(25*enemy\evilhillary)) And LevelStartTimer>=120 Then DamagePlayer(100)
	Next
	;If EntityCollided(Lysozyme,coll_enemyrobot) Then DamagePlayer(100)
	
	RotateEntity LysozymeShadow,90,EntityYaw(Lysozyme),0
	PositionEntity LysozymeShadow,EntityX(Lysozyme),0.1,EntityZ(Lysozyme)
	
	UpdatePlayerShots
	UpdateEnemyRobots
	UpdateEnemyShots
	UpdateParticles
	UpdateSmallExplosions
	UpdateRobotPieces
	
	If RedOutTimer>0 Then
		If LastRedOutTimer=0 Then RedOutGamma(100)
		LastRedOutTimer=RedOutTimer
		RedOutTimer=RedOutTimer-1
		If RedOutTimer=0 Then SetGammaIntensity(0):LastRedOutTimer=0
	EndIf

	;Adding Evil Hillary
	If AddedEvilHillary=False And LevelStartTimer>=120 Then EvilHillaryTimer=EvilHillaryTimer+1
	If EvilHillaryTimer>=1000 And AddedEvilHillary=False Then 
		AddedEvilHillary=True:w=Rand(1,2)
		cx=MazeNodeX(MazeExitNode(MazeLevel,w))
		cz=MazeNodeZ(MazeExitNode(MazeLevel,w))
		AddEnemyRobot(cx,cz,MazeExitNode(MazeLevel,w),1)
		AddSmallExplosion(cx,25,cz,2)
		PlaySound MusicEvilHillaryEnters
	EndIf
	
	WaitTimer(FrameTimer)
	UpdateWorld
	RenderWorld
	UpdateHUD
	Flip
Wend

Function SwitchView(v) ;1=FPS  2=From the back  3=From the top
	If v=CurrView Then Return
	If v=1 Then
		PositionEntity camera,0,0,-40
		RotateEntity camera,0,0,0
		EntityAlpha Lysozyme,0
		EntityAlpha CeilingMesh,1
	EndIf
	If v=2 Then
		PositionEntity camera,0,0,0
		RotateEntity camera,0,0,0
		EntityAlpha Lysozyme,0.6
		EntityAlpha CeilingMesh,1
	EndIf
End Function

Function SnapToView(v) ;1=FPS  2=From the back  3=From the top
	If v=1 Then
		PositionEntity camera,0,0,0
		;RotateEntity camera,0,0,0
		EntityAlpha Lysozyme,0
		EntityAlpha CeilingMesh,1
		EntityAlpha AimingGuide,0.3
		EntityAlpha WeaponMesh,1
	EndIf
	If v=2 Then
		PositionEntity camera,0,0,-40
		;RotateEntity camera,0,0,0
		EntityAlpha Lysozyme,0.6
		EntityAlpha CeilingMesh,1
		EntityAlpha AimingGuide,0.3
		EntityAlpha WeaponMesh,1
	EndIf
	If v=3 Then
		PositionEntity camera,0,30,-40
		PointEntity camera,Lysozyme
		EntityAlpha Lysozyme,1
		EntityAlpha CeilingMesh,0
		EntityAlpha AimingGuide,0
		EntityAlpha WeaponMesh,0
	EndIf
End Function

Function TitleScreen()
	Repeat
		Cls
		DrawBlock TitleScreenImg,0,0
		Flip
		kk=GetKey()
	Until kk=Asc(" ")
	MouseSensitivity=0.2
	Color 255,255,255:SetFont LargeFont
	Repeat
		Cls
		Text 400,200,"MOUSE SENSITIVITY",True,True
		Text 400,250,MouseSensitivity,True,True
		Text 400,500,"LEFT/RIGHT ARROWS TO CHOOSE",True,True
		Text 400,550,"PRESS SPACE WHEN DONE",True,True
		kk=GetKey()
		If kk=30 Then MouseSensitivity=MouseSensitivity+0.05
		If kk=31 Then MouseSensitivity=MouseSensitivity-0.05
		If MouseSensitivity<=0.05 Then MouseSensitivity=0.05
		If MouseSensitivity>2 Then MouseSensitivity=2
		Flip
	Until kk=32
End Function

Function RedOutGamma(n)
	For k=0 To 255
	SetGamma k,k,k,k+n,0,0
	Next
	UpdateGamma
End Function

Function SetGammaIntensity(n)
	For k=0 To 255
	SetGamma k,k,k,k+n,k+n,k+n
	Next
	UpdateGamma
End Function

Function InitializeVariables()
	co=0
	For x=1 To 5
		For z=1 To 5
			co=co+1
			MazeNodeZ(co)=(z*200)-100
			MazeNodeX(co)=(x*200)-100
		Next
	Next

	For a=1 To 4
		For b=1 To 25
			For c=1 To 5
				Read MazeNodeConn(a,b,c)
			Next
		Next
		Read MazeExitNode(a,1),MazeExitNode(a,2)
	Next

	For lev=1 To 4
		For x=1 To 11
			For z=1 To 11
				Read MazePost(lev,x,z)
			Next
		Next
	Next

	GameLevel=0:Score=0:Lives=5:ppa=0:pca=0:CurrView=1:NextExtraLife=ExtraLife
End Function

Function NewLevel(advance)
	MazeLevel=Rand(1,4):GameLevel=GameLevel+1:ScoreForLevel=0
	PlayerDeathTimer=0:LevelStartTimer=0:RedOut=0:Health=100
	RedOutTimer=0:LastRedOutTimer=0:EvilHillaryTimer=0:AddedEvilHillary=False
	Cls
	SetFont LargeFont
	Text 400,200,"LEVEL "+GameLevel,True,True
	Flip
	Delay(1000)
	
	For enemy.enemytype=Each enemytype
		FreeEntity enemy\entity:Delete enemy
	Next
	For enemyshot.enemyshottype=Each enemyshottype
		FreeEntity enemyshot\sprite:Delete enemyshot
	Next
	For mazedamage.mazedamagetype=Each mazedamagetype
		FreeEntity mazedamage\sprite:Delete mazedamage
	Next
	For playershot.playershottype=Each playershottype
		FreeEntity playershot\entity:Delete playershot
	Next
	For smallexplosion.smallexplosiontype=Each smallexplosiontype
		FreeEntity smallexplosion\entity:Delete smallexplosion
	Next
	For particle.particletype=Each particletype
		FreeEntity particle\sprite:Delete particle
	Next
	
	For robotpiece.robotpiecetype=Each robotpiecetype
		FreeEntity robotpiece\entity:Delete robotpiece
	Next
	
	For probotpiece.probotpiecetype=Each probotpiecetype
		FreeEntity probotpiece\entity:Delete probotpiece
	Next

	For explosionsound.explosionsoundtype=Each explosionsoundtype
		FreeEntity explosionsound\entity:Delete explosionsound
	Next
		
	BuildMaze(MazeLevel)
	For a=1 To 25:NodeOccupied(a)=False:Next
	
	;Add Robots
	NodeOccupied(13)=True
	If GameLevel=1 Then OriginalRobotsInMaze=Rand(3,5)
	If GameLevel>=2 And GameLevel<=5 Then OriginalRobotsInMaze=Rand(6,10)
	If GameLevel>=6 And GameLevel<=10 Then OriginalRobotsInMaze=Rand(8,16)
	If GameLevel>=11 Then OriginalRobotsInMaze=Rand(14,22)
	CurrentRobotsInMaze=OriginalRobotsInMaze
	For r=1 To OriginalRobotsInMaze
		.pick
		start=Rand(1,25)
		If NodeOccupied(start)=True Then Goto pick
		AddEnemyRobot(MazeNodeX(Start),MazeNodeZ(start),start,False)
		NodeOccupied(start)=True
	Next
	l1=GameLevel
	l2=l1
	If l2>16 Then l2=16
	While l1>16
		l1=l1-16
	Wend
	l3#=l1:l4#=l2
	RobotSpeed=1.5+((2.5*l3/16))
	RobotAnimSpeed=0.35*(1+(0.5*(l3/16)))
	RobotTurnSpeed=RobotSpeed*1.5
	RobotShootingSpeed=300/l4
	RobotShotSpeed=3+((4*(l4/16)))
	PositionEntity Lysozyme,500,0,500:RotateEntity Lysozyme,0,0,0
	RotateEntity LysozymeCameraPivot,0,0,0;:PositionEntity LysozymeCameraPivot,0,0,0
	RotateEntity camera,0,0,0
	RotateEntity AimingGuide,0,0,0
	pca=0:ppa=0:SetLysoAnim(1,0.1)
	SnapToView(CurrView)
	UpdateWorld
End Function

Function UpdateHUD()
	SetFont LargeFont
	Color 0,0,0
	Text 13,13,Score
	Text 753,13,Lives
	Text 693,553,Health+"%"
	Color 255,255,255
	Text 10,10,Score
	Text 750,10,Lives
	Text 690,550,Health+"%"
End Function

Function EndLevel()
	For b=0 To -255 Step -5
		SetGammaIntensity(b)
		UpdateWorld
	Next
	SetGammaIntensity(0)
	Cls
	
	SetFont LargeFont
	Text 200,100,"LEVEL "+GameLevel+" DONE"
	Text 100,250,"SCORE THIS LEVEL:"
	Text 100,300,"TOTAL SCORE:"
	Text 550,250,ScoreForLevel
	Text 550,300,Score
	Flip
	
	Delay 2000
	NewLevel(1)
End Function

Function BuildMaze(lev)
	For MazeWall.MazeWallType=Each MazeWallType
		FreeEntity Mazewall\ent:Delete MazeWall
	Next	
	PositionEntity FloorMesh,500,-10,500:EntityType FloorMesh,coll_mazefloor
	PositionEntity CeilingMesh,500,50,500:EntityType CeilingMesh,coll_mazeceiling
	For x=1 To 11
		For z=1 To 11
			xx=(x-1)*100:zz=(z-1)*100
			post1=MazePost(lev,x,z)
			If post1<10 Then r=0
			If post1>=10 And post1<=19 Then r=1:post1=post1-10
			If post1>=20 And post1<=29 Then r=2:post1=post1-20
			If post1>=30 And post1<=39 Then r=3:post1=post1-30
			If post1<>0 Then AddMazeElement(xx,zz,post1,r)
		Next
	Next
End Function

Function AddMazeElement(x,z,typ,rot) ;typ:1 column, 2 wall   rot 1 means rotate 90 deg clockwise   rot 2 means rotate 90 deg counterclockwise
	mazewall.mazewalltype=New mazewalltype
	mazewall\x=x
	mazewall\z=z
	If typ=1 Then mazewall\ent=CopyEntity(Wall1Mesh):EntityBox mazewall\ent,-10,0,-10,120,50,20
	If typ=2 Then mazewall\ent=CopyEntity(Wall2Mesh):EntityBox mazewall\ent,-10,0,-10,220,50,20
	If typ=3 Then mazewall\ent=CopyEntity(Wall3Mesh):EntityBox mazewall\ent,-10,0,-10,320,50,20
	If typ=4 Then mazewall\ent=CopyEntity(Wall4Mesh):EntityBox mazewall\ent,-10,0,-10,420,50,20
	If typ=5 Then mazewall\ent=CopyEntity(Wall5Mesh):EntityBox mazewall\ent,-10,0,-10,520,50,20
	If typ=6 Then mazewall\ent=CopyEntity(Wall6Mesh):EntityBox mazewall\ent,-10,0,-10,620,50,20
	If typ=7 Then mazewall\ent=CopyEntity(Wall10Mesh):EntityBox mazewall\ent,-10,0,-10,1020,50,20
	If rot=0 Then RotateEntity mazewall\ent,0,90,0
	If rot=2 Then RotateEntity mazewall\ent,0,-90,0
	If rot=3 Then RotateEntity mazewall\ent,0,180,0
	EntityType mazewall\ent,coll_mazewall
	PositionEntity mazewall\ent,mazewall\x,0,mazewall\z
End Function

Function AddPlayerShot()
	PlaySound PlayerShootSound

	PlayerShot.PlayerShotType=New PlayerShotType
	playershot\entity=CopyEntity(PlayerShotMesh)
	EntityType playershot\entity,coll_playershot
	EntityRadius playershot\entity,1
	RotateEntity playershot\entity,EntityPitch(camera,1),EntityYaw(playershotorigin,1),EntityRoll(playershotorigin,1)
	PositionEntity playershot\entity,EntityX(playershotorigin,1),EntityY(playershotorigin,1)-10,EntityZ(playershotorigin,1)
	ResetEntity playershot\entity
End Function

Function UpdatePlayerShots()
	For playershot.playershottype=Each playershottype
		MoveEntity playershot\entity,0,0,15
		If EntityX(playershot\entity)>1100 Or EntityX(playershot\entity)<-100 Then FreeEntity(playershot\entity):Delete playershot:Goto done
		If EntityZ(playershot\entity)>1100 Or EntityZ(playershot\entity)<-100 Then FreeEntity(playershot\entity):Delete playershot:Goto done
		
		If EntityCollided(playershot\entity,coll_mazewall) Or EntityCollided(playershot\entity,coll_mazefloor) Or EntityCollided(playershot\entity,coll_mazeceiling) Then 
			For k=1 To CountCollisions(playershot\entity)
				t=GetEntityType(CollisionEntity(playershot\entity,k))
				If t=coll_mazewall Or t=coll_mazefloor Or t=coll_mazeceiling Then
					cx#=CollisionX(playershot\entity,k)
					cy#=CollisionY(playershot\entity,k)
					cz#=CollisionZ(playershot\entity,k)
					nx#=CollisionNX(playershot\entity,k)
					ny#=CollisionNY(playershot\entity,k)
					nz#=CollisionNZ(playershot\entity,k)
					mazedamage.mazedamagetype=New mazedamagetype
					mazedamage\sprite=CopyEntity(ShotDamageSprite)
					PositionEntity mazedamage\sprite,cx,cy,cz
					AlignToVector mazedamage\sprite,nx,ny,nz,3
					MoveEntity mazedamage\sprite,0,0,1.5:TurnEntity mazedamage\sprite,0,180,0:TurnEntity mazedamage\sprite,0,0,Rand(0,359)
					For e=1 To 10:AddParticle(cx,cy,cz):Next
					
					AddSmallExplosion(cx,cy,cz,1)
					AddExplosionSound(cx,cy,cz,1)
					FreeEntity(playershot\entity):Delete playershot:Goto done
					Exit
				EndIf
			Next
		EndIf
		
		;Hit an enemy?
		If EntityCollided(playershot\entity,coll_enemyrobot) Then 
			ent=CollisionEntity(playershot\entity,1)
			For enemy.enemytype=Each enemytype
				If ent=enemy\entity Then DamageEnemyRobot(enemy,1)
			Next
			AddSmallExplosion(EntityX(playershot\entity),EntityY(playershot\entity),EntityZ(playershot\entity),1)
			FreeEntity playershot\entity:Delete playershot
		EndIf	
		
		.done
	Next
End Function

Function AddRobotPiece(x,y,z,typ)
	robotpiece.robotpiecetype=New robotpiecetype
	robotpiece\entity=CopyEntity(RobotPieceMesh(typ))
	PositionEntity robotpiece\entity,x,y,z
	robotpiece\mx=Rnd(-3,3)
	robotpiece\my=Rnd(-3,3)
	robotpiece\mz=Rnd(-3,3)
	robotpiece\rx=Rnd(-10,10)
	robotpiece\ry=Rnd(-10,10)
	robotpiece\rz=Rnd(-10,10)
	robotpiece\typ=typ
	EntityType robotpiece\entity,coll_robotpiece
	ResetEntity robotpiece\entity
End Function

Function UpdateRobotPieces()
	For robotpiece.robotpiecetype=Each robotpiecetype
		robotpiece\my=robotpiece\my-Gravity
		TranslateEntity robotpiece\entity,robotpiece\mx,robotpiece\my,robotpiece\mz
		TurnEntity robotpiece\entity,robotpiece\rx,robotpiece\ry,robotpiece\rz
		;If EntityCollided(robotpiece\entity,coll_mazeceiling) Then robotpiece\my=-robotpiece\my
		If EntityCollided(robotpiece\entity,coll_mazefloor) Then
			AddPermanentRobotPiece(EntityX(robotpiece\entity),EntityY(robotpiece\entity),EntityZ(robotpiece\entity),EntityYaw(robotpiece\entity),robotpiece\typ)
			FreeEntity robotpiece\entity:Delete robotpiece
		EndIf
	Next
End Function

Function AddPermanentRobotPiece(x,y,z,ry,typ)
	probotpiece.probotpiecetype=New probotpiecetype
	probotpiece\entity=CopyEntity(RobotPieceMesh(typ))
	PositionEntity probotpiece\entity,x,y,z
	RotateEntity probotpiece\entity,0,ry,0
End Function

Function AddEnemyRobot(x,z,node,evilhillary)
	enemy.enemytype=New enemytype
	If evilhillary=False Then enemy\entity=CopyEntity(CyborgVixen) Else enemy\entity=CopyEntity(EvilHillaryMesh)
	enemy\shadow=CopyEntity(ShadowSprite,enemy\entity)
	EntityType enemy\entity,coll_enemyrobot
	PositionEntity enemy\entity,x,0+(25*evilhillary),z
	RotateEntity enemy\entity,0,Rand(0,359),0
	PositionEntity enemy\shadow,EntityX(enemy\entity),0.2,EntityZ(enemy\entity),1
	RotateEntity enemy\shadow,90,0,0
	If evilhillary=1 Then ScaleSprite enemy\shadow,12,12
	enemy\lastnode=node
	enemy\destnode=node
	enemy\pa=0:enemy\ca=0
	enemy\hp=Rand(1,3)+(100000*evilhillary)
	enemy\ft=0
	enemy\evilhillary=evilhillary:enemy\bounce=0
	SetCyborgAnim(enemy,1,0.1)
End Function

Function UpdateEnemyRobots()
	If LevelStartTimer<120 Or PlayerDeathTimer<>0 Then 
		For enemy.enemytype=Each enemytype:SetCyborgAnim(enemy,1,0.1):Next
		Return
	EndIf
	;If PlayerDeathTimer<>0 Then Return
	For enemy.enemytype=Each enemytype
		If Rand(1,1000)=1 And RobotTalkTimer=0 And enemy\evilhillary=False Then 
			EmitSound(Taunt(Rand(1,3)),enemy\entity)
			RobotTalkTimer=1
		EndIf
		If Rand(1,250)=1 And enemy\evilhillary=False Then EmitSound(Beeps(Rand(1,5)),enemy\entity)   ;Cyborg sounds
		If Rand(1,100)=1 And enemy\evilhillary=True Then EmitSound(Laugh(Rand(1,3)),enemy\entity)   ;Cyborg sounds

		If RobotTalkTimer>0 Then RobotTalkTimer=RobotTalkTimer+1
		If RobotTalkTimer>1000 Then RobotTalkTimer=0
		;Face current node
		If IsTargetInArc(EntityX(enemy\entity),EntityZ(enemy\entity),EntityYaw(enemy\entity),MazeNodeX(enemy\destnode),MazeNodeZ(enemy\destnode),5)=False Then
			If TurnEnemyRobotToTarget(EntityYaw(enemy\entity),EntityX(enemy\entity),EntityZ(enemy\entity),MazeNodeX(enemy\destnode),MazeNodeZ(enemy\destnode))=True Then
				TurnEntity enemy\entity,0,-RobotTurnSpeed-(RobotTurnSpeed*enemy\evilhillary),0    ;right
			Else
				TurnEntity enemy\entity,0,RobotTurnSpeed+(RobotTurnSpeed*enemy\evilhillary),0     ;left
			EndIf
		EndIf
		
		;Has robot reached destination?
		reach=IsTargetCloserThan(EntityX(enemy\entity),EntityZ(enemy\entity),MazeNodeX(enemy\destnode),MazeNodeZ(enemy\destnode),10)
		If reach=True Then
			;Where next? (the connected node nearest the player)
			For n=1 To 5:NextNodeDist(n)=10000:NextNodeDistNo(n)=0:Next
			For n=1 To 5
				If MazeNodeConn(MazeLevel,enemy\destnode,n)=0 Then 
					NumConn=n-1:Exit
				Else
					nodeno=MazeNodeConn(MazeLevel,enemy\destnode,n)
					tx=MazeNodeX(nodeno):tz=MazeNodeZ(nodeno)
					NextNodeDist(n)=Sqr((EntityX(Lysozyme)-tx)^2+(EntityZ(Lysozyme)-tz)^2)
				EndIf
				NextNodeDistNo(n)=MazeNodeConn(MazeLevel,enemy\destnode,n)
			Next
			enemy\destnode=NextNodeDistNo(1)
			d1=NextNodeDist(1):n1=NextNodeDistNo(1)
			d2=NextNodeDist(2):n2=NextNodeDistNo(2)
			d3=NextNodeDist(3):n3=NextNodeDistNo(3)
			d4=NextNodeDist(4):n4=NextNodeDistNo(4)
			d5=NextNodeDist(5):n5=NextNodeDistNo(5)
			
			If d1<d2 And d1<d3 And d1<d4 And d1<d5 Then enemy\destnode=n1
			If d2<d1 And d2<d3 And d2<d4 And d2<d5 Then enemy\destnode=n2
			If d3<d1 And d3<d2 And d3<d4 And d3<d5 Then enemy\destnode=n3
			If d4<d1 And d4<d2 And d4<d3 And d4<d5 Then enemy\destnode=n4
			If d5<d1 And d5<d2 And d5<d3 And d5<d4 Then enemy\destnode=n5
			
			If Rand(1,3)=1 And enemy\evilhillary=False Then
				While MazeNodeConn(MazeLevel,enemy\lastnode,nn)=0
					nn=Rand(1,5)				
				Wend
				enemy\destnode=MazeNodeConn(MazeLevel,enemy\lastnode,nn)
			EndIf
			
			enemy\lastnode=enemy\destnode

		EndIf
		
		If AnimSeq(enemy\entity)=3 And AnimTime(enemy\entity)>=2 Then Animate enemy\entity,1,0.35,2,1:enemy\pa=2:enemy\ca=2
		
		SetCyborgAnim(enemy,2,RobotAnimSpeed)
		
		If AnimSeq(enemy\entity)<>3 Then MoveEntity enemy\entity,0,0,RobotSpeed+(RobotSpeed*enemy\evilhillary)
		
		If enemy\evilhillary=1 Then
			enemy\bounce=enemy\bounce+10
			If enemy\bounce>359 Then enemy\bounce=enemy\bounce-360
			PositionEntity enemy\entity,EntityX(enemy\entity),25+(5*Sin(enemy\bounce)),EntityZ(enemy\entity)
			PositionEntity enemy\shadow,EntityX(enemy\entity),0.2,EntityZ(enemy\entity),1
		EndIf
		
		;Shooting!
		enemy\ft=enemy\ft+1
		If enemy\ft>RobotShootingSpeed Then enemy\ft=RobotShootingSpeed
		cl=IsTargetCloserThan(EntityX(enemy\entity),EntityZ(enemy\entity),EntityX(Lysozyme),EntityZ(Lysozyme),600)
		ar=IsTargetInArc(EntityX(enemy\entity),EntityZ(enemy\entity),EntityYaw(enemy\entity),EntityX(Lysozyme),EntityZ(Lysozyme),45)
		If cl=True And ar=True And enemy\ft>=RobotShootingSpeed And GameLevel>1 And enemy\evilhillary=False Then 
			ang#=ATan2(EntityZ(Lysozyme)-EntityZ(enemy\entity),EntityX(Lysozyme)-EntityX(enemy\entity))
			addenemyshot(EntityX(enemy\entity),25,EntityZ(enemy\entity),ang)
			enemy\ft=0:EmitSound CyborgShootSound,enemy\entity
			SetCyborgAnim(enemy,3,0.2)
		EndIf
		
		.done2
	Next
End Function

Function DamageEnemyRobot(enemy.enemytype,dam)
	enemy\hp=enemy\hp-dam   ;Damage!
	If enemy\hp<=0 Then
		cx=EntityX(enemy\entity):cy=EntityY(enemy\entity):cz=EntityZ(enemy\entity) 
		AddExplosionSound(cx,cy,cz,2)
		For e=1 To 40:AddParticle(cx,cy,cz):Next
		For rp=1 To 8:AddRobotPiece(cx,cy+25,cz,rp):Next
			For splat=1 To 3
				mazedamage.mazedamagetype=New mazedamagetype
				mazedamage\sprite=CopyEntity(ShotDamageSprite)
				PositionEntity mazedamage\sprite,cx,0.2,cz
				RotateEntity mazedamage\sprite,90,0,0
				TurnEntity mazedamage\sprite,0,0,Rand(0,359)
				ScaleSprite mazedamage\sprite,50,50
				AddSmallExplosion(cx,cy+25,cz,2)
			Next
			FreeEntity enemy\shadow
			FreeEntity enemy\entity
			Delete enemy
		Score=Score+50:ScoreForLevel=ScoreForLevel+50
		CurrentRobotsInMaze=CurrentRobotsInMaze-1
		If CurrentRobotsInMaze=0 Then Score=Score+(2*OriginalRobotsInMaze*50):ScoreForLevel=ScoreForLevel+(2*OriginalRobotsInMaze*50):PlaySound MusicCyborgsDestroyed
		If Score>=NextExtraLife Then Lives=Lives+1:NextExtraLife=NextExtraLife+ExtraLife:PlaySound MusicExtraLife
	EndIf
End Function

Function IsTargetCloserThan(x,z,tx,tz,dist)
	d#=Sqr((tz-z)^2+(tx-x)^2)
	If d>dist Then Return False Else Return True
End Function

Function TurnEnemyRobotToTarget(yaw#,rox#,roz#,targx,targz)    ;true=right  false=left
	ro#=ATan2(targz-roz,targx-rox)
	
	ro1=ro-yaw-90
	If ro1>=360 Then ro1=ro1-360
	If ro1<0 Then ro1=ro1+360
	If ro1>=0 And ro1<=180 Then Return False Else Return True
End Function

Function IsTargetInArc(x,z,ang#,tx,tz,arc)
	ro#=ATan2(tz-z,tx-x)
	
	ro1=ro-ang-90
	ro1=ro1+180
	If ro1>=360 Then ro1=ro1-360
	If ro1<0 Then ro1=ro1+360
	
	If ro1>=180-arc And ro1<=180+arc Then Return True
	
	;If ro1>=0 And ro1<=arc Then Return True
	;If ro1>=360-arc And ro1<360 Then Return True
	Return False

End Function

Function AddEnemyShot(x,y,z,ang)
	c=0
	For enemyshot.enemyshottype=Each enemyshottype:c=c+1:Next
	If c>=10 Then Return

	enemyshot.enemyshottype=New enemyshottype
	enemyshot\sprite=CopyEntity(EnemyShotSprite)
	enemyshot\ang=ang
	EntityType enemyshot\sprite,coll_enemyshot
	EntityRadius enemyshot\sprite,5
	PositionEntity enemyshot\sprite,x,y,z
	ResetEntity enemyshot\sprite
End Function

Function UpdateEnemyShots()
	For enemyshot.enemyshottype=Each enemyshottype
		MoveEntity enemyshot\sprite,RobotShotSpeed*Cos(enemyshot\ang),0,RobotShotSpeed*Sin(enemyshot\ang)

		If EntityCollided(enemyshot\sprite,coll_mazewall) Then 
			For k=1 To CountCollisions(enemyshot\sprite)
				If GetEntityType(CollisionEntity(enemyshot\sprite,k))=coll_mazewall Then
					cx#=CollisionX(enemyshot\sprite,k)
					cy#=CollisionY(enemyshot\sprite,k)
					cz#=CollisionZ(enemyshot\sprite,k)
					nx#=CollisionNX(enemyshot\sprite,k)
					ny#=CollisionNY(enemyshot\sprite,k)
					nz#=CollisionNZ(enemyshot\sprite,k)
					mazedamage.mazedamagetype=New mazedamagetype
					mazedamage\sprite=CopyEntity(ShotDamageSprite)
					PositionEntity mazedamage\sprite,cx,cy,cz
					AlignToVector mazedamage\sprite,nx,ny,nz,3
					MoveEntity mazedamage\sprite,0,0,1:TurnEntity mazedamage\sprite,0,180,0:TurnEntity mazedamage\sprite,0,0,Rand(0,359)
					For e=1 To 10:AddParticle(cx,cy,cz):Next
					AddSmallExplosion(cx,cy,cz,1)
					AddExplosionSound(cx,cy,cz,1)
					FreeEntity enemyshot\sprite:Delete enemyshot
					Goto done3
				EndIf
			Next
		EndIf
		
		If EntityCollided(enemyshot\sprite,coll_Lysozyme) Then
			DamagePlayer(Rand(10,30))
			AddSmallExplosion(EntityX(enemyshot\sprite),EntityY(enemyshot\sprite),EntityZ(enemyshot\sprite),1)
			FreeEntity enemyshot\sprite:Delete enemyshot:Goto done3
		EndIf
		
		If EntityX(enemyshot\sprite)>1000 Or EntityX(enemyshot\sprite)<0 Then FreeEntity enemyshot\sprite:Delete enemyshot:Goto done3
		If EntityZ(enemyshot\sprite)>1000 Or EntityZ(enemyshot\sprite)<0 Then FreeEntity enemyshot\sprite:Delete enemyshot
		
		.done3
	Next
End Function

Function AddParticle(x,y,z)
	particle.particletype=New particletype
	particle\sprite=CopyEntity(ParticleSprite)
	PositionEntity particle\sprite,x,y,z
	particle\mx=Rnd(-3,3)
	particle\my=Rnd(-3,3)
	particle\mz=Rnd(-3,3)
End Function

Function UpdateParticles()
	For particle.particletype=Each particletype
		particle\my=particle\my-Gravity
		MoveEntity particle\sprite,particle\mx,particle\my,particle\mz
		If EntityY(particle\sprite)<0 Then FreeEntity(particle\sprite):Delete particle
	Next
End Function

Function AddSmallExplosion(x,y,z,typ)  ;typ 1=small   typ 2=larger
	smallexplosion.smallexplosiontype=New smallexplosiontype
	smallexplosion\entity=CopyEntity(ExplosionMesh)
	smallexplosion\size=5
	smallexplosion\alpha=1
	smallexplosion\typ=typ
	PositionEntity smallexplosion\entity,x,y,z	
End Function

Function UpdateSmallExplosions()
	For smallexplosion.smallexplosiontype=Each smallexplosiontype
		If smallexplosion\typ=1 Then sp#=0.05 Else sp#=0.02
		ScaleEntity smallexplosion\entity,smallexplosion\size,smallexplosion\size,smallexplosion\size
		smallexplosion\alpha=smallexplosion\alpha-sp:smallexplosion\size=smallexplosion\size*1.15
		EntityAlpha smallexplosion\entity,smallexplosion\alpha
		If smallexplosion\alpha<=0 Then FreeEntity smallexplosion\entity:Delete smallexplosion		
	Next
End Function

Function DamagePlayer(dam)
	If health<=0 Then Return
	Health=Health-dam
	If Health<=0 Then Health=0:PlayerDeathTimer=1:RedOutTimer=200:Return
	PlaySound Grunt(Rand(1,6)):RedOutTimer=30
End Function

Function NewPlayer()
	Lives=Lives-1:Health=100
	If Lives<0 Then GameOver
	ShowEntity Lysozyme
	PositionEntity Lysozyme,500,0,500,True:RotateEntity Lysozyme,0,0,0:ResetEntity Lysozyme
	;PositionEntity LysozymeCameraPivot,0,0,0
	RotateEntity LysozymeCameraPivot,0,0,0
	RotateEntity camera,0,0,0
	RotateEntity AimingGuide,0,0,0
	SetLysoAnim(1,0.1)
	SnapToview(1):SnapToView(2)
	SnapToView(CurrView)
End Function

Function GameOver()
	SetGammaIntensity(0)
	Cls
	SetFont LargeFont
	Text 400,200,"GAME OVER",True
	Text 400,500,"PRESS SPACE TO PLAY AGAIN",True
	Text 400,450,"PRESS ESC TO QUIT",True
	Flip
	While Not KeyDown(1)
		kk=GetKey()
		If kk=Asc(" ") Then
			GameLevel=0:Score=0:Lives=5:ppa=0:pca=0
			NextExtraLife=ExtraLife
			NewLevel(1):NewPlayer
			Return
		EndIf
	Wend
	End
End Function

Function AddExplosionSound(x,y,z,size)  ;1=small 2=large
	explosionsound.explosionsoundtype=New explosionsoundtype
	explosionsound\entity=CopyEntity(ExplosionSoundPivot)
	PositionEntity explosionsound\entity,x,y,z
	If size=1 Then EmitSound SmallExplosionSound,explosionsound\entity
	If size=2 Then EmitSound LargeExplosionSound,explosionsound\entity
End Function

Function SetLysoAnim(an,spd#)
	If ppa=an Then Return
	Animate Lysozyme,1,spd,an,1
	ppa=pca:pca=an
End Function

Function SetCyborgAnim(enemy.enemytype,an,spd#)
	If enemy\evilhillary=True Then Return
	;If AnimSeq(enemy\entity)=3 And AnimTime(enemy\entity)<2 Then Return
	If enemy\pa=an Then Return
	If an<>3 Then Animate enemy\entity,1,spd,an,1 Else Animate enemy\entity,3,spd,an,1
	enemy\pa=enemy\ca:enemy\ca=an
End Function